#ifndef HYPER_GENOM_MODEL_GENERATE_MODULE_INTERFACE_HH_
#define HYPER_GENOM_MODEL_GENERATE_MODULE_INTERFACE_HH_

#include <boost/preprocessor/cat.hpp>
#include <boost/preprocessor/control/expr_if.hpp>
#include <boost/preprocessor/list/adt.hpp>
#include <boost/preprocessor/list/for_each.hpp>
#include <boost/preprocessor/punctuation/comma.hpp>
#include <boost/preprocessor/punctuation/paren.hpp>
#include <boost/preprocessor/stringize.hpp>
#include <boost/preprocessor/tuple/elem.hpp>
#include <boost/preprocessor/tuple/to_list.hpp>

#define GENOM_MODULE_TCLSERVCLIENT_RQST(elem) \
	BOOST_PP_CAT(MODULE_NAME, \
			BOOST_PP_CAT(TclservClient, \
				BOOST_PP_CAT(BOOST_PP_TUPLE_ELEM(3, 0, elem), RqstSend)))

#define GENOM_MODULE_TCLSERVCLIENT_RCV(elem) \
	BOOST_PP_CAT(MODULE_NAME, \
			BOOST_PP_CAT(TclservClient, \
				BOOST_PP_CAT(BOOST_PP_TUPLE_ELEM(3, 0, elem), ReplyRcv)))

#define DECLARE_RQST_METHOD_TYPE(elem) \
	typedef hyper::genom_model::method< \
			BOOST_PP_TUPLE_ELEM(3, 1, elem) \
			BOOST_PP_COMMA() \
			BOOST_PP_TUPLE_ELEM(3, 2, elem) \
			BOOST_PP_COMMA() \
			BOOST_PP_CAT(MODULE_NAME, _error_t) \
			> \
			BOOST_PP_CAT(BOOST_PP_TUPLE_ELEM(3, 0, elem), _impl);

#define METHOD_NAME(elem) \
		BOOST_PP_CAT(async_, BOOST_PP_TUPLE_ELEM(3, 0, elem)) 

#define DECLARE_RQST_METHOD_INSTANCIATION(elem) \
	BOOST_PP_CAT(BOOST_PP_TUPLE_ELEM(3, 0, elem), _impl) \
		METHOD_NAME(elem) ;

#define GENOM_MODULE_INPUT(elem) \
	BOOST_PP_CAT(BOOST_PP_TUPLE_ELEM(3, 1, elem), Handler handler)

#define GENOM_MODULE_REQUEST(r, dala, elem)  \
	DECLARE_RQST_METHOD_TYPE(elem) \
	DECLARE_RQST_METHOD_INSTANCIATION(elem)

#define GENOM_POSTER(r, dala, elem) \
	hyper::genom_model::PosterReader< \
		BOOST_PP_TUPLE_ELEM(2, 1, elem) > \
		BOOST_PP_TUPLE_ELEM(2, 0, elem) ;

#define GENOM_POSTER_CTOR(r, dala, elem) \
	BOOST_PP_TUPLE_ELEM(2, 0, elem) ( \
		BOOST_PP_STRINGIZE( \
			BOOST_PP_CAT(MODULE_NAME, BOOST_PP_TUPLE_ELEM(2, 0, elem))) \
			) BOOST_PP_COMMA()


#define GENOM_MODULE_CTOR_REQUEST(r, dala, elem) \
	METHOD_NAME(elem) \
	BOOST_PP_LPAREN() \
	GENOM_MODULE_TCLSERVCLIENT_RQST(elem) \
	BOOST_PP_COMMA() \
	GENOM_MODULE_TCLSERVCLIENT_RCV(elem) \
	BOOST_PP_COMMA() \
	queue \
	BOOST_PP_RPAREN() \
	BOOST_PP_COMMA()

#define ERROR_DEFINITION \
	class BOOST_PP_CAT(MODULE_NAME, _category_impl) : public boost::system::error_category \
	{	\
		public: \
			virtual const char* name() const { return BOOST_PP_STRINGIZE(MODULE_NAME); } \
			virtual std::string message(int ev) const { return BOOST_PP_CAT(MODULE_NAME, _error_str) (ev); }; \
	}; \
	const boost::system::error_category& BOOST_PP_CAT(MODULE_NAME, _category) (); \
	boost::system::error_code make_error_code(BOOST_PP_CAT(MODULE_NAME, _error) e); \
	namespace boost {\
	namespace system {\
	  template <> \
	    struct is_error_code_enum<BOOST_PP_CAT(MODULE_NAME, _error)> \
		    : public true_type {};									 \
	}}

#define ERROR_IMPLEMENTATION \
	const boost::system::error_category& BOOST_PP_CAT(MODULE_NAME, _category) () \
	{	\
	  static BOOST_PP_CAT(MODULE_NAME, _category_impl) instance; \
	  return instance;   \
	}    \
	boost::system::error_code make_error_code(BOOST_PP_CAT(MODULE_NAME, _error) e) \
	{	\
		return boost::system::error_code(static_cast<int>(e),  \
					BOOST_PP_CAT(MODULE_NAME, _category) ()); \
	}	\


#define MODULE_DEFINITION  \
	ERROR_DEFINITION       \
	namespace hyper {	   \
		namespace genom_model { \
			struct MODULE_NAME {   \
				BOOST_PP_LIST_FOR_EACH(GENOM_MODULE_REQUEST, _, MODULE_REQUESTS)	\
				BOOST_PP_LIST_FOR_EACH(GENOM_POSTER, _, MODULE_POSTERS)				\
				hyper::genom_model::tclserv_client_queue queue; \
				boost::asio::deadline_timer timer; \
				hyper::genom_model::genom_process process; \
				typedef boost::function<void (const boost::system::error_code&)> cb_type; \
				void init(const boost::system::error_code& e, int i, cb_type cb) { \
					if (e) return cb(e); \
					if (i > 10) return cb(make_error_code(boost::system::errc::timed_out)); \
					POSTER_ID pid; \
					if (posterFind(BOOST_PP_STRINGIZE(BOOST_PP_CAT(MODULE_NAME, Cntrl)), &pid) < 0) { \
					  cb_type local_cb = boost::bind(&MODULE_NAME::init, this, boost::asio::placeholders::error, i++, cb); \
					  timer.expires_from_now(boost::posix_time::seconds(1)); \
					  return timer.async_wait(local_cb); \
					} \
					BOOST_PP_CAT(MODULE_NAME, TclservClientInit) (queue.get_client_id()); \
					cb(boost::system::error_code()); \
				} \
				MODULE_NAME(boost::asio::io_service& io_s, const std::string& addr, const std::string& port, cb_type cb) : \
					BOOST_PP_LIST_FOR_EACH(GENOM_MODULE_CTOR_REQUEST, _, MODULE_REQUESTS) \
					BOOST_PP_LIST_FOR_EACH(GENOM_POSTER_CTOR, _, MODULE_POSTERS) \
					queue(io_s, addr, port), \
					timer(io_s), \
					process(BOOST_PP_STRINGIZE(MODULE_NAME), queue) \
				{ cb_type local_cb = boost::bind(&MODULE_NAME::init, this, boost::asio::placeholders::error, 0, cb); \
				  timer.expires_from_now(boost::posix_time::seconds(1)); \
			      timer.async_wait(local_cb); \
				}\
				void abort(ssize_t id) { queue.abort(id); } \
				~MODULE_NAME() { BOOST_PP_CAT(MODULE_NAME, TclservClientEnd) (queue.get_client_id()); }\
				};	\
		}	\
	}					   

#endif
