#ifndef HYPER_COMPILER_GENOM_EXTENSION_HH_
#define HYPER_COMPILER_GENOM_EXTENSION_HH_

#include <compiler/extension.hh>

namespace hyper {
	namespace compiler {
		struct genom_extension : public extension {
			virtual void function_proto(std::ostream& oss, const functionDef& f,
												   const typeList& tList) const;
			
			virtual void function_proto_additional_includes(std::ostream& oss,
													const std::string& name) const;

			virtual void function_impl(std::ostream& oss, const functionDef& f,
												   const typeList& tList) const;

			virtual void output_import(std::ostream& oss, const functionDef& f,
														  const typeList& tList) const;

			virtual void recipe_additional_includes(std::ostream& oss, 
													const std::string& ability_name) const;

			virtual void dump_eval_expression(std::ostream& oss, 
											  const universe& u,
											  const ability& a,
											  const task& t,
											  const std::string& local_data_type,
											  const symbolList& local_symbol,
											  size_t counter,
											  const expression_ast& e) const;

			virtual void generate_expression_caller(std::ostream& oss,
												    size_t counter) const;

			virtual void generate_additional_files(const std::string& path,
												   const universe &,
												   const std::string& name) const;

			virtual std::string generate_abortable_function(const universe&,
															const ability&,
															const task&,
															const std::string&,
															size_t counter, 
															const std::string& target_var) const;
		};
	}
}

#endif /* HYPER_COMPILER_GENOM_EXTENSION_HH_ */
